#define _GNU_SOURCE

#include <fcntl.h>
#include <pwd.h>
#include <sched.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

int main() {
    char shell[128] = {0};

    struct passwd *pw = getpwent();
    strlcpy(shell, pw->pw_shell, sizeof(shell));

    endpwent();

    int fd = open("/run/vpn/net", 0);

    if (fd > 0) {
        int failure = setns(fd, CLONE_NEWNET);
        if (failure) {
            perror("setns /run/vpn/net");
        }
        close(fd);
        if (failure) {
            return 1;
        }
    } else {
        perror("open /run/vpn/net");
        return 1;
    }
    execl(shell, shell, NULL);
    perror(NULL);
    return 0;
}
